/*
 * $Id$
 * 
 * Created on 27.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;

/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public class AccessArgument extends Argument {

	/**
	 * Mandatory FAMIX attribute
	 */	
	private Access hasAccess;
	
	/**
	 * @param position
	 * @param isReceiver
	 */
	public AccessArgument(Integer position, boolean isReceiver, Access hasAccess) {
		super(position, isReceiver);
		this.hasAccess = hasAccess;
	}

	public boolean validate() {
		return super.validate() && (hasAccess != null);
	}

	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return "AccessArgument("+super.getPosition()+",isReceiver:"+super.isReceiver()+")";
	}
	
	/**
	 * @return Returns the access.
	 */
	public Access getHasAccess() {
		return hasAccess;
	}
}
