/*
 * $Id$
 * 
 * Created on 27.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;

/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public abstract class Argument extends ch.toe.famix.model.Object {

	/**
	 * Mandatory FAMIX attribute
	 */
	private Integer position;
	
	/**
	 * Mandatory FAMIX attribute
	 */
	private boolean isReceiver;
	
	/**
	 * @param position
	 * @param isReceiver
	 */
	public Argument(Integer position, boolean isReceiver) {
		super();
		this.position = position;
		this.isReceiver = isReceiver;
	}

	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return "Argument("+getPosition()+",isReceiver:"+isReceiver()+")";
	}

	/* (non-Javadoc)
	 * @see ch.toe.famix.model.Object#validate()
	 */
	public boolean validate() {
		return true;
	}

	/**
	 * @return Returns the isReceiver.
	 */
	public boolean isReceiver() {
		return isReceiver;
	}

	/**
	 * @return Returns the position.
	 */
	public Integer getPosition() {
		return position;
	}

}
