/*
 * $Id$
 * 
 * Created on 26.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;

/**
 * Note this is not defined in original FAMIX, but rather a helper class
 * for my Package and Class implementation.
 * 
 * @author tsa
 */
public abstract class Context extends Entity {

	private Context belongsTo = null;
	
	/**
	 * @param name
	 */
	public Context(String name) {
		super(name);
	}

	/**
	 * @return Returns the uniqueName.
	 */
	public String getUniqueName() {
		if (belongsTo == null)
			return super.getName();
		else
			return belongsTo.getUniqueName() + "." + super.getName();			
	}	
	
	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return getUniqueName();
	}

	/**
	 * @return Returns the belongsTo.
	 */
	public Context getBelongsTo() {
		return belongsTo;
	}
	/**
	 * @param belongsTo The belongsTo to set.
	 */
	public void setBelongsTo(Context belongsTo) {
		this.belongsTo = belongsTo;
	}
}
