/*
 * $Id$
 * 
 * Created on 20.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;

/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public abstract class Entity extends ch.toe.famix.model.Object {
	
	/**
	 * Mandatory FAMIX attribute
	 */
	private String name;
	
	/**
	 * Mandatory FAMIX attribute
	 */
	private String uniqueName;
	
	/**
	 * Default constructor
	 */	
	public Entity(String name) {
		this.name = name;
		this.uniqueName = name;
	}
	
	/**
	 * 
	 * @param name
	 * @param uniqueName
	 */
	public Entity(String name, String uniqueName) {
		this.name = name;
		this.uniqueName = uniqueName;
	}
	
	/* (non-Javadoc)
	 * @see ch.toe.famix.model.Object#validate()
	 */
	public boolean validate() {
		if (name != null)
			return true;
		return false;
	}
	
	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return getUniqueName();
	}

	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return Returns the uniqueName.
	 */
	public String getUniqueName() {
		return uniqueName;
	}
}
