/*
 * $Id$
 * 
 * Created on 22.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;

/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public class Function extends BehaviouralEntity {

	/**
	 * Optional FAMIX attribute
	 */
	private Package belongsToPackage = null;
	
	/**
	 * @param name				function name
	 * @param signature			like "function()"
	 */
	public Function(String name, String signature) {
		super(name, signature);
	}

	/**
	 * @return Returns the uniqueName. 
	 */
	public String getUniqueName() {
		if (belongsToPackage == null)
			return super.getUniqueName();
		else
			return belongsToPackage.getUniqueName() + "." + super.getSignature();
	}
	
	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return getUniqueName();
	}

	/**
	 * @return Returns the belongsToPackage.
	 */
	public Package getBelongsToPackage() {
		return belongsToPackage;
	}
	/**
	 * @param belongsToPackage The belongsToPackage to set.
	 */
	public void setBelongsToPackage(Package belongsToPackage) {
		this.belongsToPackage = belongsToPackage;
	}
}
