/*
 * $Id$
 * 
 * Created on 26.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;

/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public class GlobalVariable extends StructuralEntity {

	/**
	 * Optional FAMIX attibute
	 */
	private Package belongsToPackage = null;
	
	/**
	 * @param name
	 */
	public GlobalVariable(String name) {
		super(name);
	}

	/**
	 * @return Returns the uniqueName. 
	 */
	public String getUniqueName() {
		if (belongsToPackage == null)
			return super.getName();
		else
			return belongsToPackage.getUniqueName() + "::" + super.getName();
	}
	
	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return getUniqueName();
	}

	/**
	 * @return Returns the belongsToPackage.
	 */
	public Package getBelongsToPackage() {
		return belongsToPackage;
	}
	/**
	 * @param belongsToPackage The belongsToPackage to set.
	 */
	public void setBelongsToPackage(Package belongsToPackage) {
		this.belongsToPackage = belongsToPackage;
	}
}
