/*
 * $Id$
 * 
 * Created on 26.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;


/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public class ImplicitVariable extends StructuralEntity {

	/**
	 * Optional FAMIX attribute
	 */
	private Context belongsToContext = null;
	
	/**
	 * @param name
	 */
	public ImplicitVariable(String name) {
		super(name);
	}
	
	/**
	 * @return Returns the uniqueName. 
	 */
	public String getUniqueName() {
		if (belongsToContext == null)
			return super.getName();
		else
			return belongsToContext.getUniqueName() + "." + super.getName();
	}	

	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return getUniqueName();
	}

	/**
	 * @return Returns the belongsToContext.
	 */
	public Context getBelongsToContext() {
		return belongsToContext;
	}
	/**
	 * @param belongsToContext The belongsToContext to set.
	 */
	public void setBelongsToContext(Context belongsToContext) {
		this.belongsToContext = belongsToContext;
	}
}
