/*
 * $Id$
 * 
 * Created on 26.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;


/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public class LocalVariable extends StructuralEntity {

	/**
	 * Mandatory FAMIX attribute
	 */
	private BehaviouralEntity belongsToBehaviour;
	
	/**
	 * Optional FAMIX attribute
	 */
	private boolean isFinal = false;
	
	/**
	 * @param name
	 */
	public LocalVariable(String name, BehaviouralEntity belongsToBehaviour) {
		super(name);
		this.belongsToBehaviour = belongsToBehaviour;
	}

	/**
	 * @return Returns the uniqueName. 
	 */
	public String getUniqueName() {
		if (belongsToBehaviour == null)
			return super.getName();
		else
			return belongsToBehaviour.getUniqueName() + "." + super.getName();
	}	

	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return getUniqueName();
	}

	/**
	 * @return Returns the belongsToBehaviour.
	 */
	public BehaviouralEntity getBelongsToBehaviour() {
		return belongsToBehaviour;
	}
	/**
	 * @return Returns the isFinal.
	 */
	public boolean isFinal() {
		return isFinal;
	}
	/**
	 * @param isFinal The isFinal to set.
	 */
	public void setFinal(boolean isFinal) {
		this.isFinal = isFinal;
	}
}
