/*
 * $Id$
 * 
 * Created on 21.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;

/**
 * This defines a FAMIX Property. This is not in original FAMIX spec.
 * 
 * @author tsa
 */
public class Property {
	
	/**
	 * Mandatory FAMIX attribute
	 */
	private String name;
	
	/**
	 * Mandatory FAMIX attribute
	 */
	private String value;
	
	public Property(String name, String value) {
		this.name = name;
		this.value = value;
	}

	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return "Property: "+getName();
	}

	/**
	 * @return true if this is a valid instance
	 */
	public boolean validate() {
		if (name == null)
			return false;
		if (value == null)
			return false;
		if (name.equals(""))
			return false;
		if (value.equals(""))
			return false;
		return true;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	/**
	 * @return Returns the value.
	 */
	public String getValue() {
		return value;
	}
	/**
	 * @param value The value to set.
	 */
	public void setValue(String value) {
		this.value = value;
	}
}
