/*
 * $Id$
 * 
 * Created on 26.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;

/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public abstract class StructuralEntity extends Entity {

	/**
	 * Optional FAMIX attribute
	 * 
	 * null denotes unknown, while "" stands for void; all other
	 * values are return types (such as "int" for example)
	 */
	private String declaredType = null;

	/**
	 * Optional FAMIX attribute
	 * 
	 * null denotes no implicit class; 
	 * all other values reference the class of the return type
	 */
	private Class declaredClass;

	/**
	 * @param name
	 */
	public StructuralEntity(String name) {
		super(name);
	}

	/**
	 * Return my name
	 * 
	 * @return name of object
	 */
	public String toString() {
		return "StructuralEntity: "+super.toString();
	}

	/**
	 * @return Returns the declaredClass.
	 */
	public Class getDeclaredClass() {
		return declaredClass;
	}
	/**
	 * @param declaredClass The declaredClass to set.
	 */
	public void setDeclaredClass(Class declaredClass) {
		this.declaredClass = declaredClass;
	}
	/**
	 * @return Returns the declaredType.
	 */
	public String getDeclaredType() {
		return declaredType;
	}
	/**
	 * @param declaredType The declaredType to set.
	 */
	public void setDeclaredType(String declaredType) {
		this.declaredType = declaredType;
	}
}
