/*
 * $Id$
 * 
 * Created on 27.07.2005
 *
 * Written by Tobias Sager (tsa) in 2005
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.toe.famix.model;


/**
 * See FAMIX specification for more information about this object.
 * 
 * @author tsa
 */
public class TypeCast extends Association {

	/**
	 * Mandatory FAMIX attribute
	 */
	private BehaviouralEntity belongsToBehaviour;

	/**
	 * Optional FAMIX attribute
	 */
	private String fromType;
	
	/**
	 * Optional FAMIX attribute
	 */
	private String toType;
	
	/**
	 * @param belongsToBehaviour
	 */
	public TypeCast(BehaviouralEntity belongsToBehaviour) {
		super();
		this.belongsToBehaviour = belongsToBehaviour;
	}

	/**
	 * @return Returns the fromType.
	 */
	public String getFromType() {
		return fromType;
	}
	/**
	 * @param fromType The fromType to set.
	 */
	public void setFromType(String fromType) {
		this.fromType = fromType;
	}
	/**
	 * @return Returns the toType.
	 */
	public String getToType() {
		return toType;
	}
	/**
	 * @param toType The toType to set.
	 */
	public void setToType(String toType) {
		this.toType = toType;
	}

	/**
	 * @return Returns the belongsToBehaviour.
	 */
	public BehaviouralEntity getBelongsToBehaviour() {
		return belongsToBehaviour;
	}
}
