package ch.unibern.graphmatching2;

import java.util.*;

// Holds the components of a single tuple in a decomposition

public class Tuple {
	Graph m_parentGraph, m_subGraph1, m_subGraph2;

	Vector m_edges1_2, m_edges2_1;

	// Each tuple has a unique mapping from each of its subgraphs
	// to the parent
	private HashMap m_hashMap1, m_hashMap2;

	public Tuple(Graph parent, Graph sub1, Graph sub2, Vector edge1,
			Vector edge2, HashMap hashMap1, HashMap hashMap2) {
		m_parentGraph = parent;
		m_subGraph1 = sub1;
		m_subGraph2 = sub2;
		m_edges1_2 = edge1;
		m_edges2_1 = edge2;
		m_hashMap1 = hashMap1;
		m_hashMap2 = hashMap2;
	}

	public String printEdgeSets() {
		String result = "**** Edges 1 --> 2 ****\n";
		for (int edge = 0; edge < m_edges1_2.size(); ++edge) {
			result += ((Vertex) ((Edge) m_edges1_2.get(edge)).getSourceVertex())
					.getLabel().toString();
			result += " --> ";
			result += ((Vertex) ((Edge) m_edges1_2.get(edge)).getDestVertex())
					.getLabel().toString()
					+ "\n";
		}
		result += "**** Edges 2 --> 1 ****\n";
		for (int edge = 0; edge < m_edges2_1.size(); ++edge) {
			result += ((Vertex) ((Edge) m_edges2_1.get(edge)).getSourceVertex())
					.getLabel().toString();
			result += " --> ";
			result += ((Vertex) ((Edge) m_edges2_1.get(edge)).getDestVertex())
					.getLabel().toString()
					+ "\n";
		}
		return result;
	}

	public Graph getParent() {
		return m_parentGraph;
	}

	public Graph getSubgraph(int graphnum) {
		if (graphnum == 1)
			return m_subGraph1;
		else if (graphnum == 2)
			return m_subGraph2;
		else
			return null;
	}

	public Vector getEdgeSet(int setnum) {
		if (setnum == 1)
			return m_edges1_2;
		else if (setnum == 2)
			return m_edges2_1;
		else
			return null;
	}

	public HashMap getHashMap(int mapnum) {
		if (mapnum == 1)
			return m_hashMap1;
		else if (mapnum == 2)
			return m_hashMap2;
		else
			return null;
	}
}
