package ch.unizh.ifi.isparql.evaluation.engines.api;

import java.util.List;

/**
 * Interface for evaluation framework engines.
 * Each implemented engine extends the
 * framework abstract engine and implements this
 * interface.
 * 
 * @see ch.unizh.ifi.isparql.evaluation.engines.engine
 *
 * @author		Markus Stocker
 * @version 	$Id: IEngine.java,v 1.1 2006-11-20 18:48:54 ms Exp $
 */

public interface IEngine 
{	
	/**
	 * To implement by evaluation engines
	 * 
	 * @return List<Double>
	 */
	public abstract List<Double> run();
}
/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
