package ch.unizh.ifi.isparql.query.aggregator;

import ch.unizh.ifi.isparql.query.api.impl.AbstractAggregator;
import java.util.*;

/**
 * Average aggregator. Extension of AbstractAggregator.
 * 
 * @see			ch.unizh.ifi.isparql.query.api.impl.AbstractAggregator
 * @author		Markus Stocker
 * @version 	$Id: AvgAggregator.java,v 1.2 2006-11-21 12:41:56 ms Exp $
 */

public class AvgAggregator extends AbstractAggregator 
{	
	/** @return String */
	public String getName()
	{
		return avg;
	}
	
	/** @return double */
	public double defaultValue()
	{
		return 0d;
	}
	
	/**
	 * Aggregate a list of double values 
	 * and return the average value
	 * 
	 * @param scores
	 * @return Double
	 */
	public Double aggregate(List<Double> scores)
	{
		double sim = defaultValue();
		
		for (Double d : scores)
			sim += d;
		
		if (scores.size() > 0)
			sim = sim / scores.size();
		
		return sim;
	}
}

/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
