package ch.unizh.ifi.isparql.query.aggregator;

import ch.unizh.ifi.isparql.query.api.impl.AbstractAggregator;
import java.util.*;

/**
 * NoisyOr aggregator (WHIRL). Extension of AbstractAggregator.
 * 
 * @see			ch.unizh.ifi.isparql.query.api.impl.AbstractAggregator
 * @author		Markus Stocker
 * @version 	$Id: NoisyOrAggregator.java,v 1.2 2006-11-21 12:41:57 ms Exp $
 */

public class NoisyOrAggregator extends AbstractAggregator 
{	
	/** @return String */
	public String getName()
	{
		return noisyor;
	}
	
	/** @return double */
	public double defaultValue()
	{
		return 1d;
	}
	
	/**
	 * Aggregate list of double values
	 * and return the noisy or aggregated value.
	 * 
	 * @param List
	 * @return Double
	 */
	public Double aggregate(List<Double> scores)
	{	
		double sim = defaultValue();
			
		for (Double d : scores)
			sim *= (1d - d);

		return 1d - sim;
	}
}

/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
