package ch.unizh.ifi.isparql.query.aggregator;

import java.util.*;
import ch.unizh.ifi.isparql.query.api.impl.AbstractAggregator;

/**
 * Simple aggregator. Extension of AbstractAggregator.
 * 
 * @see			ch.unizh.ifi.isparql.query.api.impl.AbstractAggregator
 * @author		Markus Stocker
 * @version 	$Id: SimpleAggregator.java,v 1.2 2006-11-21 12:41:57 ms Exp $
 */

public class SimpleAggregator extends AbstractAggregator 
{	
	/** @return String */
	public String getName()
	{
		return simple;
	}
	
	/** @return double */
	public double defaultValue()
	{
		return 0d;
	}
	
	/**
	 * Return the first (index 0) element of a list of scores
	 * 
	 * @param scores
	 * @return Double
	 */
	public Double aggregate(List<Double> scores)
	{
		double sim = defaultValue();
		
		if (scores.size() > 0)
			sim = scores.get(0);
		
		return sim;
	}
}

/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
