package ch.unizh.ifi.isparql.query.api;

/**
 * Interface for similarity index optimization techniques,
 * used for both in-memory and persistent storage similarity indexes.
 * The aggregation optimizer uses this interface too, although this
 * optimization is finally not used in the thesis.
 * 
 * @see			ch.unizh.ifi.isparql.query.optimizer
 * @see 		ch.unizh.ifi.isparql.query.api.impl.AbstractOptimizer
 * @author		Markus Stocker
 * @version 	$Id: IOptimizer.java,v 1.3 2006-11-21 18:31:46 ms Exp $
 */

public interface IOptimizer 
{	
	/**
	 * To implement by specific optimization techniques.
	 * 
	 * @see ch.unizh.ifi.isparql.query.optimizer
	 * @return double
	 */
	public abstract Double lookup();
}
/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
