package ch.unizh.ifi.isparql.query.api;

/**
 * Interface for specific similarity strategies.
 * 
 * @see 		ch.unizh.ifi.isparql.query.strategy
 * @see			ch.unizh.ifi.isparql.query.api.impl.AbstractStrategy
 * @author		Markus Stocker
 * @version 	$Id: IStrategy.java,v 1.3 2006-11-21 18:31:46 ms Exp $
 */

public interface IStrategy 
{	
	/**
	 * To implement by specific similarity strategies.
	 * Calculate the structure and measure similarity 
	 * of simple/complex arguments.
	 * 
	 * @see ch.unizh.ifi.isparql.query.strategy
	 * @return Double
	 */
	public abstract Double similarity();

}
/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
