package ch.unizh.ifi.isparql.query.api.impl;

import ch.unizh.ifi.isparql.query.api.IOptimizer;

/**
 * Abstract iSPARQL query optimizer. 
 * The class implements the IOptimizer interface.
 * 
 * @see			ch.unizh.ifi.isparql.query.api.IOptimizer
 * @author		Markus Stocker
 * @version 	$Id: AbstractOptimizer.java,v 1.2 2006-11-21 18:31:46 ms Exp $
 */

public abstract class AbstractOptimizer implements IOptimizer 
{	
	/** 
	 * This field allows activating / disactivating the optimizer.
	 * Mainly it is used to activate or disactivate the usage of
	 * the similarity index. Please note that it should be 
	 * possible to set (configure) this in some property file,
	 * ie, outside of the framework, in order to avoid
	 * recompilation. Because of limited time, this is not done yet.
	 */
	public static final boolean optimizer = false;
	
	/** 
	 * To implement by specific optimization classes.
	 * 
	 * @see ch.unizh.ifi.isparql.query.optimizer
	 */
	public abstract Double lookup();
}
/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
