package ch.unizh.ifi.isparql.query.strategy;

import ch.unizh.ifi.isparql.query.api.impl.AbstractStrategy;
import ch.unizh.ifi.isparql.query.measure.sequence.MeasureLevenshtein;
import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.query.core.Binding;
import com.hp.hpl.jena.query.engine1.ExecutionContext;

/**
 * Levenshtein string comparison strategy
 *
 * @author		Markus Stocker
 * @version 	$Id: LevenshteinStrCmp.java,v 1.2 2006-11-21 18:31:46 ms Exp $
 */

public class LevenshteinStrCmp extends AbstractStrategy 
{
	/** The framework SimPack wrapper */
	private MeasureLevenshtein measure = new MeasureLevenshtein(this);
	
	/**
	 * Constructor
	 * 
	 * @see ch.unizh.ifi.isparql.query.StrategyFactory
	 * @param binding
	 * @param subject
	 * @param predicate
	 * @param object
	 * @param execCxt
	 */
	public LevenshteinStrCmp(Binding binding, Node subject, Node predicate, Node object, ExecutionContext execCxt)
	{
		super(binding, subject, predicate, object, execCxt);
		
		setName(AbstractStrategy.levenshteinStrCmp);
	}
	
	/**
	 * Interface implementation
	 * 
	 * @see ch.unizh.ifi.isparql.query.measure.sequence.MeasureLevenshtein
	 * @return Double
	 */
	public Double similarity()
	{		
		return measure.similarity();
	}
}
/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
