package ch.unizh.ifi.isparql.util;

/**
 * Utility class used to count elements falling into a
 * specific histogram class. Histogram data structures
 * (TreeMaps) uses this class to represent the frequency
 * of classes.
 *
 * @author		Markus Stocker
 * @version 	$Id: Counter.java,v 1.1 2006-11-20 18:48:55 ms Exp $
 */

public class Counter 
{
	/** Each counter object has a count field where the actual state is stored */
	private Integer count;
	
	/** 
	 * Constructor, set the count state to 0
	 */
	public Counter()
	{
		count = new Integer(0);
	}
	
	/**
	 * Constructor, set the count state to i (param)
	 * 
	 * @param i
	 */
	public Counter(Integer i)
	{
		count = i;
	}
	
	/** Increment the counter state */
	public void increment()
	{
		count++;
	}
	
	/** Decrement the counter state */
	public void decrement()
	{
		count--;
	}
	
	/** Get the counter state */
	public Integer getValue()
	{
		return count;
	}
	
	/** Get the counter state as string */
	public String toString()
	{
		return count.toString();
	}
}
/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
