package ch.unizh.ifi.isparql.util;

import simpack.api.impl.AbstractTokenizer;

/**
 * This tokenizer is used for Levenshtein measure to convert
 * a string to lowercase in order to satisfy the iSPARQL 
 * ignorecase attribute. The class extends the SimPack
 * AbstractTokenizer.
 *
 * @author		Markus Stocker
 * @version 	$Id: LowerCaseTokenizer.java,v 1.1 2006-11-20 18:48:55 ms Exp $
 */

public class LowerCaseTokenizer extends AbstractTokenizer
{
	protected String[] buildStringTokens(String s) {
		String[] result = new String[s.length()];

		for (int i = 0; i < s.length(); i++) {
			result[i] = s.substring(i, i + 1).toLowerCase();
		}

		return result;
	}
}
/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
