package ch.unizh.ifi.isparql.tests;

import java.util.*;

/**
 * Sample aggregator scores.
 * Class for reuse in multiple test cases
 *
 * @author		Markus Stocker
 * @version 	$Id: AggregatorSamples.java,v 1.2 2006-11-22 12:32:52 ms Exp $
 */

public class AggregatorSamples 
{	
	private List<Double> scores = new ArrayList<Double>();
	
	public AggregatorSamples() 
	{
		scores.add(1.0);
		scores.add(0.5);
		scores.add(0.3);
		scores.add(0.1);
		scores.add(0.15);
		scores.add(0.75);
		scores.add(0.9);
		scores.add(0.0);
		scores.add(0.65);
		scores.add(0.20);
	}
	
	public List<Double> getScores()
	{
		return scores;
	}
	
	public Double getSum()
	{
		Double sum = 0.0;
		
		for (Double d : scores)
			sum += d;
		
		return sum;
	}
	
	public Double getAvg()
	{
		return getSum() / scores.size();
	}
	
	public Double getGeometric()
	{
		Double val = 1.0;
		
		for (Double d : scores)
			val *= d;
		
		return Math.pow(val, 1 / new Double(scores.size()));
	}
	
	public Double getHarmonic()
	{
		Double val = 1.0;
		
		for (Double d : scores)
			val += 1 / d;
		
		return scores.size() / val;
	}
	
	public Double getMax()
	{
		Collections.sort(scores);
		
		return scores.get(scores.size() - 1);
	}
	
	public Double getMin()
	{
		Collections.sort(scores);
		
		return scores.get(0);
	}
	
	public Double getMedian()
	{
		Collections.sort(scores);
	
		int index;
		int size = scores.size();
		
		if ((size % 2) == 0)
			index = (size / 2) - 1;
		else
			index = size / 2;
		
		return scores.get(index);
	}
}
/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
