package ch.unizh.ifi.isparql.tests.query.aggregator;

import ch.unizh.ifi.isparql.tests.AggregatorSamples;
import ch.unizh.ifi.isparql.query.AggregatorFactory;
import ch.unizh.ifi.isparql.query.api.impl.AbstractAggregator;
import java.util.*;
import junit.framework.TestCase;

/**
 * SumAggregator test case
 *
 * @author		Markus Stocker
 * @version 	$Id: SumAggregatorTest.java,v 1.2 2006-11-22 12:32:52 ms Exp $
 */

public class SumAggregatorTest extends TestCase 
{	
	AggregatorSamples sample = new AggregatorSamples();
	AbstractAggregator aggregator = AggregatorFactory.create(AbstractAggregator.sum);
	
	public void testAggregator()
	{
		assertEquals(aggregator.getName(), AbstractAggregator.sum);
		
		List<Double> scores = sample.getScores();
		Double value1 = sample.getSum();
		
		// Calculate the avg value from aggregator class
		Double value2 = aggregator.aggregate(scores);
		
		assertEquals(value1, value2);
	}
}

/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
