package ch.unizh.ifi.isparql.tests.query.property;

import ch.unizh.ifi.isparql.tests.DefaultModel;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.ResultSet;
import junit.framework.TestCase;

/**
 * Test isparql:threshold, with quotes, different value
 *
 * @author		Markus Stocker
 * @version 	$Id: ThresholdTestC.java,v 1.2 2006-11-22 12:32:53 ms Exp $
 */

public class ThresholdTestC extends TestCase 
{	
	private Model model;
	private DefaultModel dm = new DefaultModel();
	
	public void testSimilarity()
	{		
		model = dm.getModel();
		
		query1();
	}
	
	private void query1()
	{	
		String qstr = "BASE					<" + DefaultModel.NS + "> " +
				      "PREFIX	person:		<" + DefaultModel.NSP + "> " +
				      "PREFIX	property:	<java:ch.unizh.ifi.isparql.query.property.> " +
				      "SELECT ?similarity " + 
				      "WHERE { " +
				      "?strategy property:name \"LevenshteinStrCmp\" . " +
				      "?strategy property:arguments (\"Markus\" \"Melanie\") . " +
				      "?strategy property:threshold \"0.2\" . " + 
				      "?strategy property:similarity ?similarity " +
				      "} " +
				      "ORDER BY DESC(?similarity) " +
				      "LIMIT 1 ";
		
		Query query = QueryFactory.create(qstr);
		QueryExecution qe = QueryExecutionFactory.create(query, model);
		ResultSet results = qe.execSelect();
		
		assertEquals(results.hasNext(), false);
	}
}

/* 
 * (c) Copyright 2007 University of Zurich, Switzerland
 * All rights reserved.
 *
 * This file is licensed under a GNU Lesser General Public License.
 *
 * For more information about license terms see LICENSE.txt that comes with
 * the main iSPARQL-OptARQ distribution or visit the GNU website at
 * http://www.gnu.org/licenses/lgpl.html
 *
 */
